*** a/contrib/auto_explain/auto_explain.c
--- b/contrib/auto_explain/auto_explain.c
***************
*** 12,17 ****
--- 12,19 ----
   */
  #include "postgres.h"
  
+ #include <limits.h>
+ 
  #include "commands/explain.h"
  #include "executor/instrument.h"
  #include "utils/guc.h"
*** a/contrib/dblink/dblink.c
--- b/contrib/dblink/dblink.c
***************
*** 34,39 ****
--- 34,40 ----
  
  #include <limits.h>
  
+ #include "access/htup.h"
  #include "libpq-fe.h"
  #include "funcapi.h"
  #include "catalog/indexing.h"
*** a/contrib/file_fdw/file_fdw.c
--- b/contrib/file_fdw/file_fdw.c
***************
*** 15,20 ****
--- 15,21 ----
  #include <sys/stat.h>
  #include <unistd.h>
  
+ #include "access/htup.h"
  #include "access/reloptions.h"
  #include "access/sysattr.h"
  #include "catalog/pg_foreign_table.h"
*** a/contrib/hstore/hstore_io.c
--- b/contrib/hstore/hstore_io.c
***************
*** 5,10 ****
--- 5,11 ----
  
  #include <ctype.h>
  
+ #include "access/htup.h"
  #include "catalog/pg_type.h"
  #include "funcapi.h"
  #include "libpq/pqformat.h"
*** a/contrib/hstore/hstore_op.c
--- b/contrib/hstore/hstore_op.c
***************
*** 4,9 ****
--- 4,10 ----
  #include "postgres.h"
  
  #include "access/hash.h"
+ #include "access/htup.h"
  #include "catalog/pg_type.h"
  #include "funcapi.h"
  #include "utils/builtins.h"
*** a/contrib/ltree/ltree_op.c
--- b/contrib/ltree/ltree_op.c
***************
*** 7,12 ****
--- 7,13 ----
  
  #include <ctype.h>
  
+ #include "access/htup.h"
  #include "catalog/pg_statistic.h"
  #include "utils/builtins.h"
  #include "utils/lsyscache.h"
*** a/contrib/pageinspect/heapfuncs.c
--- b/contrib/pageinspect/heapfuncs.c
***************
*** 25,33 ****
  
  #include "postgres.h"
  
  #include "funcapi.h"
- #include "utils/builtins.h"
  #include "miscadmin.h"
  
  Datum		heap_page_items(PG_FUNCTION_ARGS);
  
--- 25,34 ----
  
  #include "postgres.h"
  
+ #include "access/htup.h"
  #include "funcapi.h"
  #include "miscadmin.h"
+ #include "utils/builtins.h"
  
  Datum		heap_page_items(PG_FUNCTION_ARGS);
  
*** a/contrib/pageinspect/rawpage.c
--- b/contrib/pageinspect/rawpage.c
***************
*** 15,20 ****
--- 15,21 ----
  
  #include "postgres.h"
  
+ #include "access/htup.h"
  #include "catalog/catalog.h"
  #include "catalog/namespace.h"
  #include "funcapi.h"
*** a/contrib/pg_buffercache/pg_buffercache_pages.c
--- b/contrib/pg_buffercache/pg_buffercache_pages.c
***************
*** 8,13 ****
--- 8,14 ----
   */
  #include "postgres.h"
  
+ #include "access/htup.h"
  #include "catalog/pg_type.h"
  #include "funcapi.h"
  #include "storage/buf_internals.h"
*** a/contrib/tablefunc/tablefunc.c
--- b/contrib/tablefunc/tablefunc.c
***************
*** 34,39 ****
--- 34,40 ----
  
  #include <math.h>
  
+ #include "access/htup.h"
  #include "catalog/pg_type.h"
  #include "funcapi.h"
  #include "executor/spi.h"
*** a/contrib/tcn/tcn.c
--- b/contrib/tcn/tcn.c
***************
*** 15,20 ****
--- 15,21 ----
  
  #include "postgres.h"
  
+ #include "access/htup.h"
  #include "executor/spi.h"
  #include "commands/async.h"
  #include "commands/trigger.h"
*** a/contrib/xml2/xpath.c
--- b/contrib/xml2/xpath.c
***************
*** 6,11 ****
--- 6,12 ----
   */
  #include "postgres.h"
  
+ #include "access/htup.h"
  #include "executor/spi.h"
  #include "fmgr.h"
  #include "funcapi.h"
*** a/src/backend/access/common/printtup.c
--- b/src/backend/access/common/printtup.c
***************
*** 16,21 ****
--- 16,22 ----
  #include "postgres.h"
  
  #include "access/printtup.h"
+ #include "fmgr.h"
  #include "libpq/libpq.h"
  #include "libpq/pqformat.h"
  #include "tcop/pquery.h"
*** a/src/backend/access/common/reloptions.c
--- b/src/backend/access/common/reloptions.c
***************
*** 17,22 ****
--- 17,23 ----
  
  #include "access/gist_private.h"
  #include "access/hash.h"
+ #include "access/htup.h"
  #include "access/nbtree.h"
  #include "access/reloptions.h"
  #include "access/spgist.h"
*** a/src/backend/access/common/tupconvert.c
--- b/src/backend/access/common/tupconvert.c
***************
*** 21,26 ****
--- 21,27 ----
  #include "postgres.h"
  
  #include "access/tupconvert.h"
+ #include "access/htup.h"
  #include "utils/builtins.h"
  
  
*** a/src/backend/access/common/tupdesc.c
--- b/src/backend/access/common/tupdesc.c
***************
*** 19,30 ****
  
  #include "postgres.h"
  
  #include "catalog/pg_type.h"
  #include "miscadmin.h"
  #include "parser/parse_type.h"
  #include "utils/acl.h"
  #include "utils/builtins.h"
! #include "utils/resowner.h"
  #include "utils/syscache.h"
  
  
--- 19,31 ----
  
  #include "postgres.h"
  
+ #include "access/htup.h"
  #include "catalog/pg_type.h"
  #include "miscadmin.h"
  #include "parser/parse_type.h"
  #include "utils/acl.h"
  #include "utils/builtins.h"
! #include "utils/resowner_private.h"
  #include "utils/syscache.h"
  
  
*** a/src/backend/access/gin/gininsert.c
--- b/src/backend/access/gin/gininsert.c
***************
*** 15,20 ****
--- 15,22 ----
  #include "postgres.h"
  
  #include "access/gin_private.h"
+ #include "access/heapam_xlog.h"
+ #include "access/htup.h"
  #include "catalog/index.h"
  #include "miscadmin.h"
  #include "storage/bufmgr.h"
*** a/src/backend/access/gist/gistbuild.c
--- b/src/backend/access/gist/gistbuild.c
***************
*** 18,23 ****
--- 18,24 ----
  
  #include "access/genam.h"
  #include "access/gist_private.h"
+ #include "access/htup.h"
  #include "catalog/index.h"
  #include "miscadmin.h"
  #include "optimizer/cost.h"
*** a/src/backend/access/heap/heapam.c
--- b/src/backend/access/heap/heapam.c
***************
*** 40,46 ****
   */
  #include "postgres.h"
  
! #include "access/heapam.h"
  #include "access/hio.h"
  #include "access/multixact.h"
  #include "access/relscan.h"
--- 40,46 ----
   */
  #include "postgres.h"
  
! #include "access/heapam_xlog.h"
  #include "access/hio.h"
  #include "access/multixact.h"
  #include "access/relscan.h"
*** a/src/backend/access/heap/hio.c
--- b/src/backend/access/heap/hio.c
***************
*** 17,22 ****
--- 17,23 ----
  
  #include "access/heapam.h"
  #include "access/hio.h"
+ #include "access/htup.h"
  #include "access/visibilitymap.h"
  #include "storage/bufmgr.h"
  #include "storage/freespace.h"
*** a/src/backend/access/heap/pruneheap.c
--- b/src/backend/access/heap/pruneheap.c
***************
*** 15,20 ****
--- 15,22 ----
  #include "postgres.h"
  
  #include "access/heapam.h"
+ #include "access/heapam_xlog.h"
+ #include "access/htup.h"
  #include "access/transam.h"
  #include "miscadmin.h"
  #include "pgstat.h"
*** a/src/backend/access/heap/rewriteheap.c
--- b/src/backend/access/heap/rewriteheap.c
***************
*** 103,108 ****
--- 103,109 ----
  #include "postgres.h"
  
  #include "access/heapam.h"
+ #include "access/heapam_xlog.h"
  #include "access/rewriteheap.h"
  #include "access/transam.h"
  #include "access/tuptoaster.h"
*** a/src/backend/access/heap/visibilitymap.c
--- b/src/backend/access/heap/visibilitymap.c
***************
*** 83,88 ****
--- 83,89 ----
  #include "postgres.h"
  
  #include "access/heapam.h"
+ #include "access/heapam_xlog.h"
  #include "access/visibilitymap.h"
  #include "miscadmin.h"
  #include "storage/bufmgr.h"
*** a/src/backend/access/nbtree/nbtree.c
--- b/src/backend/access/nbtree/nbtree.c
***************
*** 18,23 ****
--- 18,24 ----
   */
  #include "postgres.h"
  
+ #include "access/heapam_xlog.h"
  #include "access/nbtree.h"
  #include "access/relscan.h"
  #include "catalog/index.h"
*** a/src/backend/access/nbtree/nbtsort.c
--- b/src/backend/access/nbtree/nbtsort.c
***************
*** 66,71 ****
--- 66,72 ----
  
  #include "postgres.h"
  
+ #include "access/heapam_xlog.h"
  #include "access/nbtree.h"
  #include "miscadmin.h"
  #include "storage/smgr.h"
*** a/src/backend/access/nbtree/nbtxlog.c
--- b/src/backend/access/nbtree/nbtxlog.c
***************
*** 14,19 ****
--- 14,20 ----
   */
  #include "postgres.h"
  
+ #include "access/heapam_xlog.h"
  #include "access/nbtree.h"
  #include "access/transam.h"
  #include "storage/procarray.h"
*** a/src/backend/access/spgist/spginsert.c
--- b/src/backend/access/spgist/spginsert.c
***************
*** 17,22 ****
--- 17,24 ----
  #include "postgres.h"
  
  #include "access/genam.h"
+ #include "access/heapam_xlog.h"
+ #include "access/htup.h"
  #include "access/spgist_private.h"
  #include "catalog/index.h"
  #include "miscadmin.h"
*** a/src/backend/access/transam/rmgr.c
--- b/src/backend/access/transam/rmgr.c
***************
*** 11,17 ****
  #include "access/gin.h"
  #include "access/gist_private.h"
  #include "access/hash.h"
! #include "access/heapam.h"
  #include "access/multixact.h"
  #include "access/nbtree.h"
  #include "access/spgist.h"
--- 11,17 ----
  #include "access/gin.h"
  #include "access/gist_private.h"
  #include "access/hash.h"
! #include "access/heapam_xlog.h"
  #include "access/multixact.h"
  #include "access/nbtree.h"
  #include "access/spgist.h"
*** a/src/backend/access/transam/xact.c
--- b/src/backend/access/transam/xact.c
***************
*** 38,49 ****
--- 38,51 ----
  #include "pgstat.h"
  #include "replication/walsender.h"
  #include "replication/syncrep.h"
+ #include "storage/fd.h"
  #include "storage/lmgr.h"
  #include "storage/predicate.h"
  #include "storage/proc.h"
  #include "storage/procarray.h"
  #include "storage/sinvaladt.h"
  #include "storage/smgr.h"
+ #include "utils/catcache.h"
  #include "utils/combocid.h"
  #include "utils/guc.h"
  #include "utils/inval.h"
*** a/src/backend/access/transam/xlogfuncs.c
--- b/src/backend/access/transam/xlogfuncs.c
***************
*** 16,21 ****
--- 16,22 ----
   */
  #include "postgres.h"
  
+ #include "access/htup.h"
  #include "access/xlog.h"
  #include "access/xlog_internal.h"
  #include "access/xlogutils.h"
*** a/src/backend/bootstrap/bootstrap.c
--- b/src/backend/bootstrap/bootstrap.c
***************
*** 21,26 ****
--- 21,27 ----
  #include <getopt.h>
  #endif
  
+ #include "access/htup.h"
  #include "bootstrap/bootstrap.h"
  #include "catalog/index.h"
  #include "catalog/pg_collation.h"
*** a/src/backend/catalog/aclchk.c
--- b/src/backend/catalog/aclchk.c
***************
*** 19,24 ****
--- 19,25 ----
  
  #include "access/genam.h"
  #include "access/heapam.h"
+ #include "access/htup.h"
  #include "access/sysattr.h"
  #include "access/xact.h"
  #include "catalog/catalog.h"
*** a/src/backend/catalog/dependency.c
--- b/src/backend/catalog/dependency.c
***************
*** 14,19 ****
--- 14,20 ----
   */
  #include "postgres.h"
  
+ #include "access/htup.h"
  #include "access/sysattr.h"
  #include "access/xact.h"
  #include "catalog/dependency.h"
*** a/src/backend/catalog/heap.c
--- b/src/backend/catalog/heap.c
***************
*** 29,34 ****
--- 29,35 ----
   */
  #include "postgres.h"
  
+ #include "access/htup.h"
  #include "access/sysattr.h"
  #include "access/transam.h"
  #include "access/xact.h"
*** a/src/backend/catalog/indexing.c
--- b/src/backend/catalog/indexing.c
***************
*** 15,20 ****
--- 15,21 ----
   */
  #include "postgres.h"
  
+ #include "access/htup.h"
  #include "catalog/index.h"
  #include "catalog/indexing.h"
  #include "executor/executor.h"
*** a/src/backend/catalog/namespace.c
--- b/src/backend/catalog/namespace.c
***************
*** 19,24 ****
--- 19,25 ----
   */
  #include "postgres.h"
  
+ #include "access/htup.h"
  #include "access/xact.h"
  #include "catalog/dependency.h"
  #include "catalog/pg_authid.h"
***************
*** 46,51 ****
--- 47,53 ----
  #include "storage/sinval.h"
  #include "utils/acl.h"
  #include "utils/builtins.h"
+ #include "utils/catcache.h"
  #include "utils/guc.h"
  #include "utils/inval.h"
  #include "utils/lsyscache.h"
*** a/src/backend/catalog/objectaddress.c
--- b/src/backend/catalog/objectaddress.c
***************
*** 15,20 ****
--- 15,22 ----
  
  #include "postgres.h"
  
+ #include "access/heapam.h"
+ #include "access/htup.h"
  #include "access/sysattr.h"
  #include "catalog/catalog.h"
  #include "catalog/indexing.h"
*** a/src/backend/catalog/pg_aggregate.c
--- b/src/backend/catalog/pg_aggregate.c
***************
*** 15,20 ****
--- 15,21 ----
  #include "postgres.h"
  
  #include "access/heapam.h"
+ #include "access/htup.h"
  #include "catalog/dependency.h"
  #include "catalog/indexing.h"
  #include "catalog/pg_aggregate.h"
*** a/src/backend/catalog/pg_collation.c
--- b/src/backend/catalog/pg_collation.c
***************
*** 16,21 ****
--- 16,22 ----
  
  #include "access/genam.h"
  #include "access/heapam.h"
+ #include "access/htup.h"
  #include "access/sysattr.h"
  #include "catalog/dependency.h"
  #include "catalog/indexing.h"
*** a/src/backend/catalog/pg_constraint.c
--- b/src/backend/catalog/pg_constraint.c
***************
*** 16,21 ****
--- 16,22 ----
  
  #include "access/genam.h"
  #include "access/heapam.h"
+ #include "access/htup.h"
  #include "catalog/dependency.h"
  #include "catalog/indexing.h"
  #include "catalog/objectaccess.h"
*** a/src/backend/catalog/pg_conversion.c
--- b/src/backend/catalog/pg_conversion.c
***************
*** 15,20 ****
--- 15,21 ----
  #include "postgres.h"
  
  #include "access/heapam.h"
+ #include "access/htup.h"
  #include "access/sysattr.h"
  #include "catalog/dependency.h"
  #include "catalog/indexing.h"
***************
*** 25,30 ****
--- 26,32 ----
  #include "catalog/pg_proc.h"
  #include "mb/pg_wchar.h"
  #include "utils/builtins.h"
+ #include "utils/catcache.h"
  #include "utils/fmgroids.h"
  #include "utils/rel.h"
  #include "utils/syscache.h"
*** a/src/backend/catalog/pg_db_role_setting.c
--- b/src/backend/catalog/pg_db_role_setting.c
***************
*** 10,15 ****
--- 10,16 ----
   */
  #include "postgres.h"
  
+ #include "access/htup.h"
  #include "access/genam.h"
  #include "access/heapam.h"
  #include "catalog/indexing.h"
*** a/src/backend/catalog/pg_depend.c
--- b/src/backend/catalog/pg_depend.c
***************
*** 16,21 ****
--- 16,22 ----
  
  #include "access/genam.h"
  #include "access/heapam.h"
+ #include "access/htup.h"
  #include "catalog/dependency.h"
  #include "catalog/indexing.h"
  #include "catalog/pg_constraint.h"
*** a/src/backend/catalog/pg_enum.c
--- b/src/backend/catalog/pg_enum.c
***************
*** 15,20 ****
--- 15,21 ----
  
  #include "access/genam.h"
  #include "access/heapam.h"
+ #include "access/htup.h"
  #include "access/xact.h"
  #include "catalog/catalog.h"
  #include "catalog/indexing.h"
***************
*** 23,28 ****
--- 24,30 ----
  #include "storage/lmgr.h"
  #include "miscadmin.h"
  #include "utils/builtins.h"
+ #include "utils/catcache.h"
  #include "utils/fmgroids.h"
  #include "utils/syscache.h"
  #include "utils/tqual.h"
*** a/src/backend/catalog/pg_inherits.c
--- b/src/backend/catalog/pg_inherits.c
***************
*** 21,26 ****
--- 21,27 ----
  
  #include "access/genam.h"
  #include "access/heapam.h"
+ #include "access/htup.h"
  #include "catalog/indexing.h"
  #include "catalog/pg_inherits.h"
  #include "catalog/pg_inherits_fn.h"
*** a/src/backend/catalog/pg_largeobject.c
--- b/src/backend/catalog/pg_largeobject.c
***************
*** 16,21 ****
--- 16,22 ----
  
  #include "access/genam.h"
  #include "access/heapam.h"
+ #include "access/htup.h"
  #include "access/sysattr.h"
  #include "catalog/dependency.h"
  #include "catalog/indexing.h"
*** a/src/backend/catalog/pg_namespace.c
--- b/src/backend/catalog/pg_namespace.c
***************
*** 15,20 ****
--- 15,21 ----
  #include "postgres.h"
  
  #include "access/heapam.h"
+ #include "access/htup.h"
  #include "catalog/dependency.h"
  #include "catalog/indexing.h"
  #include "catalog/objectaccess.h"
*** a/src/backend/catalog/pg_operator.c
--- b/src/backend/catalog/pg_operator.c
***************
*** 18,23 ****
--- 18,24 ----
  #include "postgres.h"
  
  #include "access/heapam.h"
+ #include "access/htup.h"
  #include "access/xact.h"
  #include "catalog/dependency.h"
  #include "catalog/indexing.h"
*** a/src/backend/catalog/pg_proc.c
--- b/src/backend/catalog/pg_proc.c
***************
*** 14,19 ****
--- 14,20 ----
   */
  #include "postgres.h"
  
+ #include "access/htup.h"
  #include "access/xact.h"
  #include "catalog/dependency.h"
  #include "catalog/indexing.h"
*** a/src/backend/catalog/pg_range.c
--- b/src/backend/catalog/pg_range.c
***************
*** 16,21 ****
--- 16,22 ----
  
  #include "access/genam.h"
  #include "access/heapam.h"
+ #include "access/htup.h"
  #include "catalog/dependency.h"
  #include "catalog/indexing.h"
  #include "catalog/pg_collation.h"
*** a/src/backend/catalog/pg_shdepend.c
--- b/src/backend/catalog/pg_shdepend.c
***************
*** 16,21 ****
--- 16,22 ----
  
  #include "access/genam.h"
  #include "access/heapam.h"
+ #include "access/htup.h"
  #include "access/xact.h"
  #include "catalog/catalog.h"
  #include "catalog/dependency.h"
*** a/src/backend/catalog/pg_type.c
--- b/src/backend/catalog/pg_type.c
***************
*** 15,20 ****
--- 15,21 ----
  #include "postgres.h"
  
  #include "access/heapam.h"
+ #include "access/htup.h"
  #include "access/xact.h"
  #include "catalog/dependency.h"
  #include "catalog/indexing.h"
*** a/src/backend/commands/aggregatecmds.c
--- b/src/backend/commands/aggregatecmds.c
***************
*** 22,27 ****
--- 22,28 ----
   */
  #include "postgres.h"
  
+ #include "access/htup.h"
  #include "access/heapam.h"
  #include "catalog/dependency.h"
  #include "catalog/indexing.h"
*** a/src/backend/commands/alter.c
--- b/src/backend/commands/alter.c
***************
*** 14,19 ****
--- 14,20 ----
   */
  #include "postgres.h"
  
+ #include "access/htup.h"
  #include "catalog/dependency.h"
  #include "catalog/indexing.h"
  #include "catalog/namespace.h"
*** a/src/backend/commands/collationcmds.c
--- b/src/backend/commands/collationcmds.c
***************
*** 14,19 ****
--- 14,20 ----
   */
  #include "postgres.h"
  
+ #include "access/htup.h"
  #include "access/heapam.h"
  #include "access/xact.h"
  #include "catalog/dependency.h"
*** a/src/backend/commands/comment.c
--- b/src/backend/commands/comment.c
***************
*** 16,21 ****
--- 16,22 ----
  
  #include "access/genam.h"
  #include "access/heapam.h"
+ #include "access/htup.h"
  #include "catalog/indexing.h"
  #include "catalog/objectaddress.h"
  #include "catalog/pg_description.h"
*** a/src/backend/commands/constraint.c
--- b/src/backend/commands/constraint.c
***************
*** 13,18 ****
--- 13,19 ----
   */
  #include "postgres.h"
  
+ #include "access/htup.h"
  #include "catalog/index.h"
  #include "commands/trigger.h"
  #include "executor/executor.h"
*** a/src/backend/commands/conversioncmds.c
--- b/src/backend/commands/conversioncmds.c
***************
*** 15,20 ****
--- 15,21 ----
  #include "postgres.h"
  
  #include "access/heapam.h"
+ #include "access/htup.h"
  #include "catalog/dependency.h"
  #include "catalog/indexing.h"
  #include "catalog/pg_conversion.h"
*** a/src/backend/commands/copy.c
--- b/src/backend/commands/copy.c
***************
*** 21,26 ****
--- 21,27 ----
  #include <arpa/inet.h>
  
  #include "access/heapam.h"
+ #include "access/htup.h"
  #include "access/sysattr.h"
  #include "access/xact.h"
  #include "catalog/namespace.h"
*** a/src/backend/commands/createas.c
--- b/src/backend/commands/createas.c
***************
*** 21,26 ****
--- 21,27 ----
   */
  #include "postgres.h"
  
+ #include "access/htup.h"
  #include "access/reloptions.h"
  #include "access/sysattr.h"
  #include "access/xact.h"
*** a/src/backend/commands/dbcommands.c
--- b/src/backend/commands/dbcommands.c
***************
*** 26,31 ****
--- 26,32 ----
  
  #include "access/genam.h"
  #include "access/heapam.h"
+ #include "access/htup.h"
  #include "access/xact.h"
  #include "access/xlogutils.h"
  #include "catalog/catalog.h"
***************
*** 45,50 ****
--- 46,52 ----
  #include "pgstat.h"
  #include "postmaster/bgwriter.h"
  #include "storage/copydir.h"
+ #include "storage/fd.h"
  #include "storage/lmgr.h"
  #include "storage/ipc.h"
  #include "storage/procarray.h"
*** a/src/backend/commands/dropcmds.c
--- b/src/backend/commands/dropcmds.c
***************
*** 16,21 ****
--- 16,22 ----
  #include "postgres.h"
  
  #include "access/heapam.h"
+ #include "access/htup.h"
  #include "catalog/dependency.h"
  #include "catalog/namespace.h"
  #include "catalog/objectaddress.h"
*** a/src/backend/commands/event_trigger.c
--- b/src/backend/commands/event_trigger.c
***************
*** 13,18 ****
--- 13,19 ----
   */
  #include "postgres.h"
  
+ #include "access/htup.h"
  #include "access/xact.h"
  #include "catalog/dependency.h"
  #include "catalog/indexing.h"
*** a/src/backend/commands/extension.c
--- b/src/backend/commands/extension.c
***************
*** 27,32 ****
--- 27,33 ----
  #include <limits.h>
  #include <unistd.h>
  
+ #include "access/htup.h"
  #include "access/sysattr.h"
  #include "access/xact.h"
  #include "catalog/dependency.h"
***************
*** 45,50 ****
--- 46,52 ----
  #include "funcapi.h"
  #include "mb/pg_wchar.h"
  #include "miscadmin.h"
+ #include "storage/fd.h"
  #include "tcop/utility.h"
  #include "utils/builtins.h"
  #include "utils/fmgroids.h"
*** a/src/backend/commands/foreigncmds.c
--- b/src/backend/commands/foreigncmds.c
***************
*** 14,19 ****
--- 14,20 ----
  #include "postgres.h"
  
  #include "access/heapam.h"
+ #include "access/htup.h"
  #include "access/xact.h"
  #include "access/reloptions.h"
  #include "catalog/dependency.h"
*** a/src/backend/commands/functioncmds.c
--- b/src/backend/commands/functioncmds.c
***************
*** 33,38 ****
--- 33,39 ----
  #include "postgres.h"
  
  #include "access/genam.h"
+ #include "access/htup.h"
  #include "access/heapam.h"
  #include "access/sysattr.h"
  #include "catalog/dependency.h"
*** a/src/backend/commands/indexcmds.c
--- b/src/backend/commands/indexcmds.c
***************
*** 15,20 ****
--- 15,21 ----
  
  #include "postgres.h"
  
+ #include "access/htup.h"
  #include "access/reloptions.h"
  #include "access/xact.h"
  #include "catalog/catalog.h"
*** a/src/backend/commands/opclasscmds.c
--- b/src/backend/commands/opclasscmds.c
***************
*** 19,24 ****
--- 19,25 ----
  
  #include "access/genam.h"
  #include "access/heapam.h"
+ #include "access/htup.h"
  #include "access/nbtree.h"
  #include "access/sysattr.h"
  #include "catalog/dependency.h"
*** a/src/backend/commands/operatorcmds.c
--- b/src/backend/commands/operatorcmds.c
***************
*** 35,40 ****
--- 35,41 ----
  #include "postgres.h"
  
  #include "access/heapam.h"
+ #include "access/htup.h"
  #include "catalog/dependency.h"
  #include "catalog/indexing.h"
  #include "catalog/pg_operator.h"
*** a/src/backend/commands/proclang.c
--- b/src/backend/commands/proclang.c
***************
*** 15,20 ****
--- 15,21 ----
  
  #include "access/genam.h"
  #include "access/heapam.h"
+ #include "access/htup.h"
  #include "catalog/dependency.h"
  #include "catalog/indexing.h"
  #include "catalog/objectaccess.h"
*** a/src/backend/commands/schemacmds.c
--- b/src/backend/commands/schemacmds.c
***************
*** 14,19 ****
--- 14,21 ----
   */
  #include "postgres.h"
  
+ #include "access/heapam.h"
+ #include "access/htup.h"
  #include "access/xact.h"
  #include "catalog/catalog.h"
  #include "catalog/dependency.h"
*** a/src/backend/commands/seclabel.c
--- b/src/backend/commands/seclabel.c
***************
*** 12,17 ****
--- 12,18 ----
  
  #include "access/genam.h"
  #include "access/heapam.h"
+ #include "access/htup.h"
  #include "catalog/catalog.h"
  #include "catalog/indexing.h"
  #include "catalog/pg_seclabel.h"
*** a/src/backend/commands/sequence.c
--- b/src/backend/commands/sequence.c
***************
*** 14,19 ****
--- 14,20 ----
   */
  #include "postgres.h"
  
+ #include "access/htup.h"
  #include "access/transam.h"
  #include "access/xlogutils.h"
  #include "catalog/dependency.h"
*** a/src/backend/commands/tablecmds.c
--- b/src/backend/commands/tablecmds.c
***************
*** 15,21 ****
  #include "postgres.h"
  
  #include "access/genam.h"
! #include "access/heapam.h"
  #include "access/reloptions.h"
  #include "access/relscan.h"
  #include "access/sysattr.h"
--- 15,21 ----
  #include "postgres.h"
  
  #include "access/genam.h"
! #include "access/heapam_xlog.h"
  #include "access/reloptions.h"
  #include "access/relscan.h"
  #include "access/sysattr.h"
*** a/src/backend/commands/tablespace.c
--- b/src/backend/commands/tablespace.c
***************
*** 52,57 ****
--- 52,58 ----
  #include <sys/stat.h>
  
  #include "access/heapam.h"
+ #include "access/htup.h"
  #include "access/reloptions.h"
  #include "access/sysattr.h"
  #include "access/xact.h"
*** a/src/backend/commands/trigger.c
--- b/src/backend/commands/trigger.c
***************
*** 15,20 ****
--- 15,21 ----
  
  #include "access/genam.h"
  #include "access/heapam.h"
+ #include "access/htup.h"
  #include "access/sysattr.h"
  #include "access/xact.h"
  #include "catalog/catalog.h"
*** a/src/backend/commands/tsearchcmds.c
--- b/src/backend/commands/tsearchcmds.c
***************
*** 17,24 ****
  
  #include <ctype.h>
  
- #include "access/heapam.h"
  #include "access/genam.h"
  #include "access/xact.h"
  #include "catalog/dependency.h"
  #include "catalog/indexing.h"
--- 17,25 ----
  
  #include <ctype.h>
  
  #include "access/genam.h"
+ #include "access/heapam.h"
+ #include "access/htup.h"
  #include "access/xact.h"
  #include "catalog/dependency.h"
  #include "catalog/indexing.h"
*** a/src/backend/commands/typecmds.c
--- b/src/backend/commands/typecmds.c
***************
*** 33,38 ****
--- 33,39 ----
  
  #include "access/genam.h"
  #include "access/heapam.h"
+ #include "access/htup.h"
  #include "access/xact.h"
  #include "catalog/catalog.h"
  #include "catalog/dependency.h"
*** a/src/backend/commands/user.c
--- b/src/backend/commands/user.c
***************
*** 14,19 ****
--- 14,20 ----
  
  #include "access/genam.h"
  #include "access/heapam.h"
+ #include "access/htup.h"
  #include "access/xact.h"
  #include "catalog/dependency.h"
  #include "catalog/indexing.h"
*** a/src/backend/commands/vacuum.c
--- b/src/backend/commands/vacuum.c
***************
*** 25,30 ****
--- 25,31 ----
  #include "access/clog.h"
  #include "access/genam.h"
  #include "access/heapam.h"
+ #include "access/htup.h"
  #include "access/transam.h"
  #include "access/xact.h"
  #include "catalog/namespace.h"
*** a/src/backend/commands/vacuumlazy.c
--- b/src/backend/commands/vacuumlazy.c
***************
*** 39,44 ****
--- 39,46 ----
  
  #include "access/genam.h"
  #include "access/heapam.h"
+ #include "access/heapam_xlog.h"
+ #include "access/htup.h"
  #include "access/transam.h"
  #include "access/visibilitymap.h"
  #include "catalog/storage.h"
*** a/src/backend/commands/variable.c
--- b/src/backend/commands/variable.c
***************
*** 18,23 ****
--- 18,24 ----
  
  #include <ctype.h>
  
+ #include "access/htup.h"
  #include "access/xact.h"
  #include "catalog/pg_authid.h"
  #include "commands/variable.h"
*** a/src/backend/executor/execAmi.c
--- b/src/backend/executor/execAmi.c
***************
*** 12,17 ****
--- 12,18 ----
   */
  #include "postgres.h"
  
+ #include "access/htup.h"
  #include "executor/execdebug.h"
  #include "executor/nodeAgg.h"
  #include "executor/nodeAppend.h"
*** a/src/backend/executor/execMain.c
--- b/src/backend/executor/execMain.c
***************
*** 37,42 ****
--- 37,44 ----
   */
  #include "postgres.h"
  
+ #include "access/htup.h"
+ #include "access/reloptions.h"
  #include "access/sysattr.h"
  #include "access/transam.h"
  #include "access/xact.h"
*** a/src/backend/executor/execQual.c
--- b/src/backend/executor/execQual.c
***************
*** 36,41 ****
--- 36,42 ----
  
  #include "postgres.h"
  
+ #include "access/htup.h"
  #include "access/nbtree.h"
  #include "access/tupconvert.h"
  #include "catalog/pg_type.h"
*** a/src/backend/executor/execTuples.c
--- b/src/backend/executor/execTuples.c
***************
*** 88,95 ****
   */
  #include "postgres.h"
  
! #include "funcapi.h"
  #include "catalog/pg_type.h"
  #include "nodes/nodeFuncs.h"
  #include "storage/bufmgr.h"
  #include "utils/builtins.h"
--- 88,96 ----
   */
  #include "postgres.h"
  
! #include "access/htup.h"
  #include "catalog/pg_type.h"
+ #include "funcapi.h"
  #include "nodes/nodeFuncs.h"
  #include "storage/bufmgr.h"
  #include "utils/builtins.h"
*** a/src/backend/executor/functions.c
--- b/src/backend/executor/functions.c
***************
*** 14,19 ****
--- 14,20 ----
   */
  #include "postgres.h"
  
+ #include "access/htup.h"
  #include "access/xact.h"
  #include "catalog/pg_proc.h"
  #include "catalog/pg_type.h"
*** a/src/backend/executor/nodeAgg.c
--- b/src/backend/executor/nodeAgg.c
***************
*** 78,83 ****
--- 78,84 ----
  
  #include "postgres.h"
  
+ #include "access/htup.h"
  #include "catalog/pg_aggregate.h"
  #include "catalog/pg_proc.h"
  #include "catalog/pg_type.h"
*** a/src/backend/executor/nodeHash.c
--- b/src/backend/executor/nodeHash.c
***************
*** 24,29 ****
--- 24,30 ----
  #include <math.h>
  #include <limits.h>
  
+ #include "access/htup.h"
  #include "catalog/pg_statistic.h"
  #include "commands/tablespace.h"
  #include "executor/execdebug.h"
*** a/src/backend/executor/nodeHashjoin.c
--- b/src/backend/executor/nodeHashjoin.c
***************
*** 15,20 ****
--- 15,21 ----
  
  #include "postgres.h"
  
+ #include "access/htup.h"
  #include "executor/executor.h"
  #include "executor/hashjoin.h"
  #include "executor/nodeHash.h"
*** a/src/backend/executor/nodeLockRows.c
--- b/src/backend/executor/nodeLockRows.c
***************
*** 21,26 ****
--- 21,27 ----
  
  #include "postgres.h"
  
+ #include "access/htup.h"
  #include "access/xact.h"
  #include "executor/executor.h"
  #include "executor/nodeLockRows.h"
*** a/src/backend/executor/nodeModifyTable.c
--- b/src/backend/executor/nodeModifyTable.c
***************
*** 37,42 ****
--- 37,43 ----
  
  #include "postgres.h"
  
+ #include "access/htup.h"
  #include "access/xact.h"
  #include "commands/trigger.h"
  #include "executor/executor.h"
*** a/src/backend/executor/nodeSetOp.c
--- b/src/backend/executor/nodeSetOp.c
***************
*** 44,49 ****
--- 44,50 ----
  
  #include "postgres.h"
  
+ #include "access/htup.h"
  #include "executor/executor.h"
  #include "executor/nodeSetOp.h"
  #include "utils/memutils.h"
*** a/src/backend/executor/nodeSubplan.c
--- b/src/backend/executor/nodeSubplan.c
***************
*** 18,25 ****
--- 18,27 ----
   */
  #include "postgres.h"
  
+ #include <limits.h>
  #include <math.h>
  
+ #include "access/htup.h"
  #include "executor/executor.h"
  #include "executor/nodeSubplan.h"
  #include "nodes/makefuncs.h"
*** a/src/backend/executor/nodeWindowAgg.c
--- b/src/backend/executor/nodeWindowAgg.c
***************
*** 33,38 ****
--- 33,39 ----
   */
  #include "postgres.h"
  
+ #include "access/htup.h"
  #include "catalog/pg_aggregate.h"
  #include "catalog/pg_proc.h"
  #include "catalog/pg_type.h"
*** a/src/backend/executor/spi.c
--- b/src/backend/executor/spi.c
***************
*** 14,19 ****
--- 14,20 ----
   */
  #include "postgres.h"
  
+ #include "access/htup.h"
  #include "access/printtup.h"
  #include "access/sysattr.h"
  #include "access/xact.h"
*** a/src/backend/foreign/foreign.c
--- b/src/backend/foreign/foreign.c
***************
*** 12,17 ****
--- 12,18 ----
   */
  #include "postgres.h"
  
+ #include "access/htup.h"
  #include "access/reloptions.h"
  #include "catalog/pg_foreign_data_wrapper.h"
  #include "catalog/pg_foreign_server.h"
*** a/src/backend/nodes/print.c
--- b/src/backend/nodes/print.c
***************
*** 20,25 ****
--- 20,26 ----
  #include "postgres.h"
  
  #include "access/printtup.h"
+ #include "fmgr.h"
  #include "nodes/print.h"
  #include "optimizer/clauses.h"
  #include "parser/parsetree.h"
*** a/src/backend/optimizer/path/costsize.c
--- b/src/backend/optimizer/path/costsize.c
***************
*** 70,75 ****
--- 70,76 ----
  
  #include <math.h>
  
+ #include "access/htup.h"
  #include "executor/executor.h"
  #include "executor/nodeHash.h"
  #include "miscadmin.h"
